diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index 5940c6dc8..a8a760262 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -7,7 +7,9 @@ import com.google.gson.JsonParser;
 import com.google.gson.stream.JsonReader;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.guidebook.SlotGuidebook;
 import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.CompareFunc;
@@ -17,20 +19,18 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.render.texturepack.TexturePackList;
-import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.core.WeightedRandomBag;
-import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.client.gui.guidebook.SlotGuidebook;
+import net.minecraft.core.player.inventory.slot.Slot;
+import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.helper.NBTFormatHelper;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
-
 import org.slf4j.Logger;
 
 import java.io.IOException;
@@ -51,54 +51,61 @@ public class TooltipElement extends Gui {
     Minecraft mc;
     FontRenderer fontRenderer;
 
-    public TooltipElement(Minecraft mc) {
+    private static final int SCREEN_MARGIN = 12;
+
+    public TooltipElement(@NotNull Minecraft mc) {
         this.mc = mc;
         this.fontRenderer = mc.font;
     }
 
-    public static final int BASE_PADDING = 3;
-    public static final int LINE_SPACING = 3;
-
     public void render(final CharSequence string, final int x, final int y, final int offsetX, final int offsetY) {
         render(string, x, y, offsetX, offsetY, -1, -1, true);
     }
 
-    public void render(final CharSequence chars, int x, int y, int offsetX, int offsetY, int maxWidth, int maxHeight, boolean canOffset) {
-        GLRenderer.pushFrame();
-        GLRenderer.setDepthFunc(CompareFunc.ALWAYS);
+    public void render(final CharSequence chars, int mouseX, int mouseY, int offsetX, int offsetY, int maxWidth, int maxHeight, boolean canOffset) {
         maxWidth = maxWidth == -1 ? Integer.MAX_VALUE : maxWidth;
-        maxHeight = maxHeight == -1 ? Integer.MAX_VALUE : maxHeight;
-
         final List<String> lines = new ArrayList<>();
         this.fontRenderer.splitCharsIntoLines(chars, maxWidth, lines);
-        int width = 0;
-        for (final String line : lines) {
-            width = Math.max(width, this.fontRenderer.stringWidth(line) - 1);
-        }
 
-        final int height = MathHelper.ceil(this.fontRenderer.heightOfLines(lines, maxWidth) - 1);
+        if (lines.isEmpty()) return;
 
-        // Flip tooltip X if it goes offscreen to the right
-        if (canOffset && x + offsetX + width > this.mc.resolution.getScaledWidthScreenCoords()) {
-            offsetX = -offsetX - width;
+        // raw dimensions
+        int rawWidth = 0;
+        for (final String line : lines) {
+            rawWidth = Math.max(rawWidth, this.fontRenderer.stringWidth(line) - 1);
         }
+        int rawHeight = MathHelper.ceil(this.fontRenderer.heightOfLines(lines, maxWidth) - 1);
+        int padding = getPadding();
 
-        if (canOffset) {
-            // Move tooltip up when it goes offscreen to the bottom
-            offsetY -= Math.max(0, y + height + offsetY - this.mc.resolution.getScaledHeightScreenCoords());
-        }
+        // screen bounds
+        int screenW = this.mc.resolution.getScaledWidthScreenCoords();
+        int screenH = this.mc.resolution.getScaledHeightScreenCoords();
 
+        int finalX = mouseX + offsetX;
+        int finalY = mouseY + offsetY;
 
-        x += offsetX;
-        y += offsetY;
+        if (canOffset) {
+            if (finalX + rawWidth > screenW - SCREEN_MARGIN) {
+                finalX = mouseX - rawWidth - offsetX;
+            }
+            if (finalY + rawHeight > screenH - SCREEN_MARGIN) {
+                finalY = screenH - rawHeight - SCREEN_MARGIN;
+            }
 
-        final int padding = getPadding();
+            finalX = MathHelper.clamp(finalX, SCREEN_MARGIN, screenW - rawWidth - SCREEN_MARGIN);
+            finalY = MathHelper.clamp(finalY, SCREEN_MARGIN, screenH - rawHeight - SCREEN_MARGIN);
+        }
 
-        drawBackground(x, y, x + width, y + height);
-//        drawRect(x, y, x + width, y + height, 0xFFFFFFFF);
+        // render
+        GLRenderer.pushFrame();
+        try {
+            GLRenderer.setDepthFunc(CompareFunc.ALWAYS);
+            drawBackground(finalX, finalY, finalX + rawWidth, finalY + rawHeight);
 
-        this.fontRenderer.renderWidthConstrained(chars, x + padding, y + padding, maxWidth).call();
-        GLRenderer.popFrame();
+            this.fontRenderer.renderWidthConstrained(chars, finalX + padding, finalY + padding, maxWidth).call();
+        } finally {
+            GLRenderer.popFrame();
+        }
     }
 
     public int getPadding() {
@@ -123,7 +130,7 @@ public class TooltipElement extends Gui {
         return drawBackground(x, y, x + width, y + height);
     }
 
-    private int[] drawBackground(final int minX, final int minY, final int maxX, final int maxY) {
+    private int @NotNull [] drawBackground(final int minX, final int minY, final int maxX, final int maxY) {
         final Style style = styleMap.getOrDefault(GameSettings.TOOLTIP_STYLE.value, defaultStyle);
         if (style != null) {
             GLRenderer.pushFrame();
@@ -150,21 +157,23 @@ public class TooltipElement extends Gui {
         return new int[]{minX, minY};
     }
 
+    public String getTooltipText(ItemStack itemStack, boolean showDescription) {
+        return getTooltipText(itemStack, showDescription, null);
+    }
+
     public String getTooltipText(ItemStack itemStack, boolean showDescription, Slot slot) {
         I18n trans = I18n.getInstance();
         StringBuilder text = new StringBuilder();
+
         boolean discovered = true;
-        boolean ctrlPressed = false;
-        boolean shiftPressed = false;
+        boolean ctrlPressed = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
+        boolean shiftPressed = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
         boolean debug = GameSettings.SHOW_ITEM_DEBUG_INFO.value;
 
         if (slot != null) {
             discovered = slot.getIsDiscovered(this.mc.thePlayer);
 
             if (slot instanceof SlotResult) {
-                ctrlPressed = Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL);
-                shiftPressed = Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) || Keyboard.isKeyDown(Keyboard.KEY_RSHIFT);
-
                 showDescription = false;
                 if (GameSettings.SWAP_CRAFTING_BUTTONS.value) {
                     boolean temp = shiftPressed;
@@ -175,42 +184,49 @@ public class TooltipElement extends Gui {
         }
 
         if (discovered) {
-            text.append(TextFormatting.get(itemStack.getDisplayColor()));
-            text.append(itemStack.getDisplayName());
-            if (itemStack.getData().containsKey("tileEntityData"))
-                text.append(" ").append(TextFormatting.MAGENTA).append(TextFormatting.ITALIC).append("+NBT").append(TextFormatting.RESET).append(TextFormatting.get(itemStack.getDisplayColor()));
-
+            text.append(TextFormatting.get(itemStack.getDisplayColor()))
+                    .append(itemStack.getDisplayName())
+                    .append(TextFormatting.RESET);
+
+            if (itemStack.getData().containsKey("tileEntityData")) {
+                if (debug) {
+                    text.append(" ")
+                        .append(TextFormatting.MAGENTA)
+                        .append(TextFormatting.ITALIC)
+                        .append("+NBT")
+                        .append(TextFormatting.RESET)
+                        .append(TextFormatting.get(itemStack.getDisplayColor()));
+                } else {
+                    text.append(" ")
+                        .append(TextFormatting.MAGENTA)
+                        .append("•")
+                        .append(TextFormatting.RESET);
+                }
+            }
 
             if (debug) {
                 text.append(" #").append(itemStack.itemID).append(":").append(itemStack.getMetadata());
             }
 
-            if (slot instanceof SlotGuidebook) {
-                if (((SlotGuidebook) slot).recipe != null) {
-                    if (((SlotGuidebook) slot).recipe instanceof RecipeEntryTrommel) {
-                        RecipeSymbol input = (RecipeSymbol) ((SlotGuidebook) slot).recipe.getInput();
-                        if (!input.matches(slot.getItemStack())) {
-                            WeightedRandomBag<?> bag = (WeightedRandomBag<?>) ((SlotGuidebook) slot).recipe.getOutput();
-                            double percent = bag.getAsPercentage(slot.getItemStack());
-                            text.append('\n').append(TextFormatting.LIGHT_GRAY).append(String.format("%.2f", percent)).append("%");
-                        }
-                    }
+            if (slot instanceof SlotGuidebook slotGuidebook && slotGuidebook.recipe instanceof RecipeEntryTrommel) {
+                RecipeSymbol input = (RecipeSymbol) slotGuidebook.recipe.getInput();
+                if (!input.matches(slot.getItemStack())) {
+                    WeightedRandomBag<?> bag = (WeightedRandomBag<?>) slotGuidebook.recipe.getOutput();
+                    double percent = bag.getAsPercentage(slot.getItemStack());
+                    text.append('\n').append(TextFormatting.LIGHT_GRAY).append(String.format("%.2f", percent)).append("%");
                 }
             }
 
             if (debug) {
                 text.append('\n').append(TextFormatting.LIGHT_GRAY).append(itemStack.getItem().namespaceID);
                 text.append('\n').append(TextFormatting.LIGHT_GRAY).append(itemStack.getItemKey());
-                text.append('\n').append(TextFormatting.LIGHT_GRAY).append("NBT: ").append(itemStack.getData().getValue().size()).append(" Tags");
 
                 if (slot instanceof SlotGuidebook slotGuidebook) {
                     if (slotGuidebook.recipe != null) {
                         text.append('\n').append(TextFormatting.GRAY).append(slotGuidebook.recipe);
                     }
-                    if (slotGuidebook.symbol != null) {
-                        if (slotGuidebook.symbol.getItemGroup() != null) {
-                            text.append('\n').append(TextFormatting.GRAY).append("Accepts any: ").append(slotGuidebook.symbol.getItemGroup());
-                        }
+                    if (slotGuidebook.symbol != null && slotGuidebook.symbol.getItemGroup() != null) {
+                        text.append('\n').append(TextFormatting.GRAY).append("Accepts any: ").append(slotGuidebook.symbol.getItemGroup());
                     }
                 }
             }
@@ -222,23 +238,32 @@ public class TooltipElement extends Gui {
                 text.append('\n').append(TextFormatting.LIGHT_GRAY).append(remainingUses + 1).append(" / ").append(durability + 1);
             }
 
-            if (showDescription) {
-                text.append('\n').append(formatDescription(itemStack.getItemDescription(), 16));
+            if (showDescription && !debug) {
+                text.append('\n').append(formatDescription(itemStack.getItemDescription()));
             } else if (!(slot instanceof SlotResult) && GameSettings.ITEM_DESCRIPTIONS.value != DescriptionPromptEnum.NEVER_PROMPT) {
-                text.append('\n').append(formatDescription(trans.translateKeyAndFormat("gui.tooltip.prompt.description", GameSettings.KEY_DESCRIPTION.getKeyName()), 16));
+                text.append('\n').append(formatDescription(trans.translateKeyAndFormat("gui.tooltip.prompt.description", GameSettings.KEY_DESCRIPTION.getKeyName())));
             }
 
             if (slot instanceof SlotResult) {
                 if (shiftPressed && !ctrlPressed) {
                     text.append('\n').append(TextFormatting.LIGHT_GRAY).append("Craft Stack");
-                }
-                if (ctrlPressed && !shiftPressed) {
+                } else if (ctrlPressed && !shiftPressed) {
                     text.append('\n').append(TextFormatting.LIGHT_GRAY).append("Craft Once");
-                }
-                if (ctrlPressed && shiftPressed) {
+                } else if (ctrlPressed) {
                     text.append('\n').append(TextFormatting.LIGHT_GRAY).append("Craft All");
                 }
             }
+
+            if (debug && !itemStack.getData().getValue().isEmpty()) {
+                if (ctrlPressed) {
+                    text.append('\n').append(NBTFormatHelper.formatNbtTooltip(itemStack.getData().toString()));
+                } else {
+                    int tagCount = itemStack.getData().getValue().size();
+                    String tagWord = tagCount == 1 ? " Tag" : " Tags";
+                    text.append('\n').append(TextFormatting.GRAY).append(tagCount).append(tagWord).append(" <CTRL>");
+                }
+            }
+
         } else {
             String translatedName = itemStack.getDisplayName();
             for (char c : translatedName.toCharArray()) {
@@ -258,21 +283,15 @@ public class TooltipElement extends Gui {
         return text.toString();
     }
 
-    public String getTooltipText(ItemStack itemStack, boolean showDescription) {
-        return getTooltipText(itemStack, showDescription, null);
-    }
-
-    private static String formatDescription(String description, int preferredLineLength) {
+    private static @NotNull String formatDescription(@NotNull String description) {
         StringBuilder string = new StringBuilder();
 
         string.append(TextFormatting.LIGHT_GRAY);
 
         int lineLength = 0;
-        for (int i = 0; i < description.length(); i++) {
-            char c = description.charAt(i);
-
+        for (char c : description.toCharArray()) {
             if (c == ' ') {
-                if (lineLength > preferredLineLength) {
+                if (lineLength > 16) {
                     lineLength = 0;
                     string.append("\n").append(TextFormatting.LIGHT_GRAY);
                 } else {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentDynamicTooltip.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentDynamicTooltip.java
index df19902d8..897b8b483 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentDynamicTooltip.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentDynamicTooltip.java
@@ -9,9 +9,9 @@ import net.minecraft.client.option.Option;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.Time;
 import org.jetbrains.annotations.NotNull;
 
@@ -23,6 +23,7 @@ public class HudComponentDynamicTooltip extends HudComponentMovable {
     private String itemString;
     private int itemColor;
     private double itemTime = 0.0;
+    private boolean itemHasNbt = false;
 
     private String systemString;
     private int systemColor;
@@ -58,7 +59,11 @@ public class HudComponentDynamicTooltip extends HudComponentMovable {
 
     @Override
     public int getTrueXSize() {
-        return mc.font.stringWidth(getDisplayText());
+        int width = mc.font.stringWidth(getDisplayText());
+        if (this.itemTime > 0.0 && this.itemHasNbt) {
+            width += mc.font.stringWidth(" •");
+        }
+        return width;
     }
 
     private String getDisplayText() {
@@ -107,7 +112,7 @@ public class HudComponentDynamicTooltip extends HudComponentMovable {
             activeTime = this.itemTime;
         }
 
-        if (activeString == null || activeTime <= 0.0) return;
+        if (activeString == null) return;
 
         double alpha = (activeTime < this.fadeTime) ? (activeTime / this.fadeTime) : 1.0;
         int a = (int) (alpha * 255);
@@ -125,6 +130,15 @@ public class HudComponentDynamicTooltip extends HudComponentMovable {
 
         mc.font.render(activeString, x, y).setShadow().setColor(rgb).call();
 
+        if (activeString.equals(this.itemString) && this.itemHasNbt) {
+            int nameWidth = mc.font.stringWidth(activeString);
+
+            int magenta = Colors.allChatColors[TextFormatting.MAGENTA.id].getARGB();
+            int bulletColor = (magenta & 0x00FFFFFF) | (a << 24);
+
+            mc.font.render(" •", x + nameWidth, y).setShadow().setColor(bulletColor).call();
+        }
+
         GLRenderer.disableState(State.BLEND);
     }
 
@@ -142,10 +156,12 @@ public class HudComponentDynamicTooltip extends HudComponentMovable {
     private void updateItemString(ItemStack item) {
         if (item == null) {
             this.itemString = null;
+            this.itemHasNbt = false;
             return;
         }
         this.itemString = item.getDisplayName();
         this.itemColor = Colors.allChatColors[item.getDisplayColor()].getARGB();
+        this.itemHasNbt = item.getData().containsKey("tileEntityData");
     }
 
     private int getItemID(ItemStack stack) {
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 2c6b86736..118ad0166 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -20,6 +20,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -279,12 +280,8 @@ public abstract class PlayerController {
         final @NotNull Block<?> block = world.getBlockType(tilePos);
 
         if (player.getHeldObject() == null) {
-            if (player.isSneaking() && itemStack == null) { // If crouched and hand empty try to pickup block entity
-                final @Nullable TileEntity tileEntity = world.getTileEntity(tilePos);
-                if (tileEntity != null && tileEntity.canBeCarried(world, player)) {
-                    player.setHeldObject(tileEntity.pickup(world, player));
-                    return true;
-                }
+            if (player.isSneaking() && itemStack == null) {
+                if (ICarrySource.tryPickUpFromWorld(world, player, tilePos) != null) return true;
             }
             if (!player.isSneaking() || itemStack == null) {  // If standing or hand empty perform block right click method
                 if (block.onInteracted(world, tilePos, player, side, xPlaced, yPlaced)) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBed.java
index b97790131..da3036cf0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBed.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericBed.java
@@ -21,7 +21,7 @@ public class BlockModelGenericBed<T extends BlockLogic> extends BlockModelGeneri
 
     @Override
     public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
-        int direction = BlockLogicBed.getDirection(worldSource.getBlockData(tilePos));
+        int direction = BlockLogicBed.DIRECTION.get(worldSource.getBlockData(tilePos));
         return switch (direction) {
             case 0 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
             case 1 -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
@@ -32,6 +32,6 @@ public class BlockModelGenericBed<T extends BlockLogic> extends BlockModelGeneri
 
     @Override
     public @NotNull StaticBlockModel getModelFromData(int data) {
-        return BlockLogicBed.isBlockHeadOfBed(data) ? this.head : this.staticModel;
+        return BlockLogicBed.IS_HEAD.bool(data) ? this.head : this.staticModel;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index af1e997ee..271270fd2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -16,7 +16,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.motion.ICarriedBlock;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.MathHelper;
@@ -68,7 +68,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
     }
 
     public void drawHeldObject(final Player player, final float partialTick) {
-        if (player.getHeldObject() instanceof CarriedBlock carriedBlock) {
+        if (player.getHeldObject() instanceof ICarriedBlock carriedBlock) {
             if (this.container == null || this.container.world != player.world) {
                 this.container = new BlocksContainer(player.world);
             }
@@ -91,18 +91,18 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
 
             this.container.setLightReferenceEntity(player);
             this.container.partialTick = partialTick;
-            this.container.setBlock(blockPos.x, blockPos.y, blockPos.z, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
+            this.container.setBlock(blockPos.x, blockPos.y, blockPos.z, carriedBlock.block().id(), carriedBlock.metadata(), carriedBlock.entity());
             BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(GLRenderer.getTessellator(), this.container, blockPos);
             tessellator.draw();
             tessellator.setTranslation(0, 0, 0);
             this.container.setLightReferenceEntity(null);
             this.container.clear();
 
-            final TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(carriedBlock.entity);
+            final TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(carriedBlock.entity());
             if (renderer != null) {
-                carriedBlock.entity.worldObj = player.world;
-                renderer.doRender(tessellator, carriedBlock.entity, -0.5, -0.5, -0.5, partialTick);
-                carriedBlock.entity.worldObj = null;
+                carriedBlock.entity().worldObj = player.world;
+                renderer.doRender(tessellator, carriedBlock.entity(), -0.5, -0.5, -0.5, partialTick);
+                carriedBlock.entity().worldObj = null;
             }
 
             GLRenderer.popFrame();
